> For the complete documentation index, see [llms.txt](https://docs.dragonswap.app/dragonswap/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/periphery/libraries/transferhelper.md).

# TransferHelper

### Functions[​](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#functions) <a href="#functions" id="functions"></a>

#### safeTransferFrom[​](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#safetransferfrom) <a href="#safetransferfrom" id="safetransferfrom"></a>

```solidity
  function safeTransferFrom(
    address token,
    address from,
    address to,
    uint256 value
  ) internal
```

Transfers tokens from the targeted address to the given destination Errors with 'STF' if transfer fails

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#parameters)

| Name    | Type    | Description                                                       |
| ------- | ------- | ----------------------------------------------------------------- |
| `token` | address | The contract address of the token to be transferred               |
| `from`  | address | The originating address from which the tokens will be transferred |
| `to`    | address | The destination address of the transfer                           |
| `value` | uint256 | The amount to be transferred                                      |

#### safeTransfer[​](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#safetransfer) <a href="#safetransfer" id="safetransfer"></a>

```solidity
  function safeTransfer(
    address token,
    address to,
    uint256 value
  ) internal
```

Transfers tokens from msg.sender to a recipient

Errors with ST if transfer fails

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#parameters-1)

| Name    | Type    | Description                                                 |
| ------- | ------- | ----------------------------------------------------------- |
| `token` | address | The contract address of the token which will be transferred |
| `to`    | address | The recipient of the transfer                               |
| `value` | uint256 | The value of the transfer                                   |

#### safeApprove[​](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#safeapprove) <a href="#safeapprove" id="safeapprove"></a>

```solidity
  function safeApprove(
    address token,
    address to,
    uint256 value
  ) internal
```

Approves the stipulated contract to spend the given allowance in the given token

Errors with 'SA' if transfer fails

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#parameters-2)

| Name    | Type    | Description                                                       |
| ------- | ------- | ----------------------------------------------------------------- |
| `token` | address | The contract address of the token to be approved                  |
| `to`    | address | The target of the approval                                        |
| `value` | uint256 | The amount of the given token the target will be allowed to spend |

#### safeTransferSEI[​](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#safetransfereth) <a href="#safetransfereth" id="safetransfereth"></a>

```solidity
  function safeTransferETH(
    address to,
    uint256 value
  ) internal
```

Transfers SEI to the recipient address

Fails with `STE`

**Parameters:**[**​**](https://docs.uniswap.org/contracts/v3/reference/periphery/libraries/TransferHelper#parameters-3)

| Name    | Type    | Description                     |
| ------- | ------- | ------------------------------- |
| `to`    | address | The destination of the transfer |
| `value` | uint256 | The value to be transferred     |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/periphery/libraries/transferhelper.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
